import { Controller, EventListenerController } from '@a11d/lit';
export class PointerController extends Controller {
    constructor(host, options) {
        var _a, _b, _c, _d;
        super(host);
        this.host = host;
        this.options = options;
        this._hover = false;
        this.anchorPointerIn = new EventListenerController(this.host, {
            type: 'pointerenter',
            target: (_b = (_a = this.options) === null || _a === void 0 ? void 0 : _a.target) !== null && _b !== void 0 ? _b : this.host,
            listener: () => this.hover = true
        });
        this.anchorPointerOut = new EventListenerController(this.host, {
            type: 'pointerleave',
            target: (_d = (_c = this.options) === null || _c === void 0 ? void 0 : _c.target) !== null && _d !== void 0 ? _d : this.host,
            listener: () => this.hover = false
        });
    }
    get hover() { return this._hover; }
    set hover(value) {
        var _a, _b;
        if (value !== this._hover) {
            this._hover = value;
            (_b = (_a = this.options) === null || _a === void 0 ? void 0 : _a.handleHoverChange) === null || _b === void 0 ? void 0 : _b.call(_a, value);
            this.host.requestUpdate();
        }
    }
}
